.nolist
include \masm32\include\masm32rt.inc
include timers.asm

.686
.xmm

markl_CountFileLines	PROTO: DWORD ,:DWORD
CompteurLignes		PROTO: DWORD, :DWORD
SetTestFichier		PROTO :DWORD
OuvrirLecture		PROTO :DWORD
ChargerFichierMem       PROTO: DWORD, :DWORD

	LOOP_COUNT = 5000
	FichMem    struc
		Hmem     dd ?
		Mpoint   dd ?
		Taille   dd ?
	FichMem    ends 

.data
cbFile	dd 0
hFile	dd 0
Win$	dd 0
bytesread	dd 0

wininc	db "\masm32\include\windows.inc", 0
;----------- compteur lignes mask -------------------
sse2entree 	db 13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,0 
sse2line	db 10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,0

windowsinc	FichMem <>
InfosFichiers WIN32_FIND_DATA <>
theWinInc db "\masm32\include\windows.inc",0
couldntfind db "Couldn't FIND",0
NomComplet db MAX_PATH dup (0)			

.code

start:
	invoke ChargerFichierMem,addr theWinInc,addr windowsinc
	.if eax != FALSE	
		print "Counting lines of "
		print offset wininc, ":", 13, 10, 10
		print "markl_CountFileLines:", 13, 10
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke markl_CountFileLines, windowsinc.Mpoint,windowsinc.Taille
			mov esi, eax
		counter_end
		print str$(eax), 9, "cycles for "	
		print str$(esi), " lines, "
		print str$(windowsinc.Taille), " bytes", 13, 10, 10
		
		print "CompteurLignes:", 13, 10
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			invoke CompteurLignes,windowsinc.Mpoint,windowsinc.Taille 
			mov esi, eax
		counter_end
		print str$(eax), 9, "cycles for "	
		print str$(esi), " lines, "		
		print str$(windowsinc.Taille), " bytes", 13, 10, 10
		inkey "Hit any key"
      	invoke   GlobalUnlock,windowsinc.Mpoint
      	invoke   GlobalFree,windowsinc.Hmem			
	.elseif
		invoke MessageBox,NULL,ADDR theWinInc ,addr couldntfind ,MB_OK		
	.endif	
	exit

markl_CountFileLines proc src:DWORD,taille:DWORD	; [url=http://www.masm32.com/board/index.php?topic=5434.msg40666#msg40666]Mark Larson[/url]
  mov eax,0a0a0a0ah

  movd xmm7,eax
  mov edx, src ;[esp+4]	; Win$	; offset [pFilebuffer]
  pshufd xmm7,xmm7,00000000b
  mov ecx,taille 

  pxor xmm6, xmm6

  shr ecx,11 ;divide by 128*16
  jnc evenly_divisible
  inc ecx
evenly_divisible:

@@:
  pxor xmm5, xmm5
  ;i think it is the unrolling that is hosing things.
  i = 0
  WHILE i LT (16*128)
	movdqu xmm0, [edx + i +  0]
	movdqu xmm1, [edx + i + 16]
	movdqu xmm2, [edx + i + 32]
	movdqu xmm3, [edx + i + 48]

	pcmpeqb xmm0, xmm7
	pcmpeqb xmm1, xmm7
	pcmpeqb xmm2, xmm7
	pcmpeqb xmm3, xmm7

	paddb xmm0, xmm1
	paddb xmm2, xmm3

	paddb xmm0, xmm2

	; can't you do this step outside the loop?  I am pretty sure you can.
	psubb xmm5, xmm0 ; total 128*8 max = 1K
	i=i+16*4
  ENDM

; unpack MM5 to get sum in 1K block
pxor xmm0, xmm0
psadbw xmm5, xmm0
paddd xmm6, xmm5

dec ecx
lea edx, [edx + 128*16]
jne @B

movd eax, xmm6
psrldq xmm6,8 ;shift Right 8 bytes
movd ebx, xmm6
add eax, ebx
ret 
markl_CountFileLines ENDP


CompteurLignes PROC uses ebx edi esi pmem:DWORD,taille:DWORD
			local  theEnd:dword,retenue:DWORD
			Local  retour:DWORD
	;init of various register
	mov retenue,0
	lea eax,sse2entree
	movups xmm6,[eax]
	lea eax,sse2line
	movups xmm7,[eax]
	mov eax,pmem
	add eax,taille
	mov theEnd,eax
	mov edx,pmem
	mov eax,0	;line counter
	;ready
	NewBloc:
	mov edx,pmem
	movups xmm1,[edx]			;load 16 bytes
	movups xmm2,[edx]			;charger les mmes 16 bytes
	pcmpeqb  xmm1,xmm6		;13 ,xmm1 modified
	;ff 00 ff 00 ff 00 ff 00-00 00 00 00 00 00 00 00  ;example of modified xmm1 in the dugger
	pcmpeqb  xmm2,xmm7		;10 ,xmm2 modified	
	;00 ff 00 ff 00 ff 00 ff-00 00 00 00 00 00 00 00  ;modified xmm2
	;--------- debug ---------
	;lea edx,TamponVisu1		;just here to view the result in the debugger
	;movups [edx],xmm1
	;lea edx,TamponVisu2	
	;movups [edx],xmm2		
	;-------- debug ------------------
	;the ;ff 00 ff .... must be read right to left
	;ecx and edx must be read left to right
	pmovmskb ecx, xmm1 ;1010101	;result for 13 in ecx  
	pmovmskb edx, xmm2 ;10101010	;result for 10 in edx
	;each 13 are now only  a  bit in ecx
	;each 10 are now only a bit in edx 
	;---------- search for bits and there positions -------
	;instructions are internal and very fast
	;ecx and edx have now her bits set to 1 as the same position 
	
	.if retenue == 1
		;the last 16 bytes loaded was ended by a 13,bit 15
		;Test if bit zero is one (there is a 10)
		bsf  edi,edx		;search the 10
		.if edi == 0 && edx != 0	
			btr edx,edi			;delet the bit find in edx,10
			inc eax			;inc the number of lines
		.endif				
	.endif
	NewEntree:
	bsf	ebx,ecx			;give the position of one bit at 1
	.if ebx == 0 && ecx != 0
		;le bit zero est a 1
		jmp bitzero13a1
	.endif
	.if ebx				;not zero ,on a un 13			
		bitzero13a1:
		btr ecx,ebx			;efface le bit trouv dans ecx
		.if ebx != 15
			inc ebx		      ;incrmente sa positon pour la comparer au 10
		.elseif
			mov retenue,1	;le 10 va se trouver dans le chargement suivant
			jmp NewSeriede16
			;suite a voir
		.endif
		
		traiteretenue:
		bsf  edi,edx		;cherche le 0A
		.if edi == 0 && edx != 0
			;le bit zero des 10 est a 1
			jmp bitzero10a1
		.endif
		.if  edi
			bitzero10a1:
			btr edx,edi			;efface le bit trouv dans edx,10			
			.if ebx == edi	;un 10 suit immdiatement le 13		
				inc eax	;////////// inc the number of lines /////////////////
			.elseif ebx >edi
				;this 10 is alone
				;c'est un 10 isol avant le 13 ,HTML
				mov edi,0
				jmp traiteretenue 
			.endif
		.endif
		;------ conditions de rebouclage ---------------
		.if ecx != 0
			mov ebx,0		;avoid an undeterminated state
			mov edi,0
			jmp NewEntree
		.endif
	.endif
	NewSeriede16:
	mov edx,pmem
	add edx,16	
	mov pmem,edx
	.if edx < theEnd
		jmp NewBloc
	.endif

 FindeCompteurLignes:
         ret
CompteurLignes endp


 ChargerFichierMem proc NomAediter:DWORD,PileMem:DWORD
		LOCAL retour:DWORD
		LOCAL fichier:DWORD
		local hMemory:DWORD
		local pMemory:DWORD
		local HeFile:DWORD
		local NbOctetsaLire:DWORD
		local NbOctetsLus:DWORD
	PUSHAD
	jmp overtext
	ercharge db "Taille ",0
	texthou db " Handle fichier ",0
	textHmem db "Handle memoire ",0
	textPm db "Pointeur memoire ",0
	textlu db " Nb octets en lecture ",0
	overtext:
	invoke SetTestFichier,NomAediter	   	
	.if eax==FALSE        
		mov retour,0
		jmp FindeChargerFichierMem
	.else
		mov fichier,eax
	.endif
	mov ebx,PileMem 

	;----------------------------
	;  ouvrir le fichier
	;----------------------------
	invoke OuvrirLecture,fichier
	.if eax==INVALID_HANDLE_VALUE
		;invoke  MessageBox,NULL,SADD(" Erreur d'ouverture Fichier "),\
		;			SADD("ChargerFichierMem"),MB_OK
		mov retour,0
		jmp FindeChargerFichierMem
	.endif 
	mov HeFile,eax 

	;-------------------------
	;obtenir le handle de mmoire, taille du fichier dw 
	;-------------------------
	mov ecx,InfosFichiers.nFileSizeLow
	mov dword ptr (FichMem ptr [ebx]).Taille,ecx
	;----------- the markl_CountFileLines need a 16 0 at end
	inc ecx		;pour rajouter le zero en fin de fichier
	;and ecx,0FFFFFFF0h	;rounded 16 bytes upper
	invoke GlobalAlloc,GMEM_MOVEABLE or GMEM_ZEROINIT,ecx
					
	.if eax == 0
		;invoke  MessageBox,NULL,SADD("Pas assez de place mmoire "),\
		;			SADD("GlobalAlloc"),MB_OK
		mov retour,0
		jmp FindeChargerFichierMem
	.endif            
	mov  hMemory,eax
	mov dword ptr (FichMem ptr [ebx]).Hmem,eax
	;obtenir le pointeur de memoire
	invoke GlobalLock,hMemory
	mov  pMemory,eax
	mov dword ptr (FichMem ptr [ebx]).Mpoint,eax

	mov eax,InfosFichiers.nFileSizeLow  
	mov NbOctetsaLire,eax
	invoke ReadFile,HeFile,pMemory,NbOctetsaLire,addr NbOctetsLus,NULL
			
	;-------------------------
	;libr la memoire ,ferm le fichier ouvert
	;-------------------------
		; invoke GlobalUnlock,pMemory
		; invoke GlobalFree,hMemory
	invoke CloseHandle,HeFile
		mov retour,1
FindeChargerFichierMem:
		popad
		mov eax,retour
		ret
ChargerFichierMem endp

 SetTestFichier proc  NomaTester:DWORD
		;rcrit le nom complet valide dans NomComplet
		;chec retourne zro , russite adresse de NomComplet
	local HSearch:DWORD
	local retour:DWORD
	pushad
	invoke RtlZeroMemory,addr InfosFichiers,sizeof InfosFichiers	
	jmp overtext
	debug db 0
	FicErreur db " le fichier n'existe pas (SetTestFichier) ! ",0
	barre db "\",0
		overtext:
	;recomposer le chemin complet si necessaire
	invoke GetCurrentDirectory,sizeof NomComplet,addr NomComplet
	invoke lnstr,NomaTester
	mov ecx,eax
	mov al,"\"
	mov edi,NomaTester
	add edi,ecx
	std
	repne scasb
	cld
		.if ecx==0
		; nom sans chemin
		invoke szCatStr,addr NomComplet,addr barre 
		invoke szCatStr,addr NomComplet,NomaTester
	.else
		;recopier le nom complet dans NomComplet
		invoke lnstr,NomaTester
		mov ecx,eax
		;ajoute le zero
		mov esi , NomaTester
		lea edi,NomComplet
			cld	
		rep movsb
			mov al,0
		stosb	  	
	.endif
	
	;----------------------------------------------------------------
	;non obligatoire mais tellement utile pour connaitre le fichier !
	;----------------------------------------------------------------
	invoke FindFirstFile,addr NomComplet,addr InfosFichiers
		
	;----------------------------------------------------------
	; taille du fichier nFileSizeHigh; DWORD    nFileSizeLow WIN32_FIND_DATA
	;   nom court ou nom long sans chemin ?         
	;-----------------------------------------------------------
	
	.if eax==INVALID_HANDLE_VALUE		 
		;InsTxt MsgERRSetTestFichier, "SetTestFichier"		; Nom de la fonction ayant echou
		;invoke RetrouveMessageErreur, ADDR MsgERRSetTestFichier	; la boite de message
		mov retour,0          
		jmp FindeSetTestFichier
	.endif
	mov HSearch,eax
	; fermer la recherche
	invoke FindClose,HSearch
	lea eax,NomComplet
	mov retour,eax
	;------------------------------------------------------         
	; on connait maintenant toutes les infos sur le fichier          
	;-------------------------------------------------------
	
FindeSetTestFichier:  
	popad
	mov eax,retour	                 
	ret             
SetTestFichier endp
OuvrirLecture proc NomaOuvrir:Dword
           invoke CreateFile,NomaOuvrir,\
                        GENERIC_READ,NULL,\
                        NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
          .if eax==INVALID_HANDLE_VALUE
		push eax
          ;invoke  MessageBox,NULL,SADD("erreur ouverture fichier "),\
          ;            SADD("OuvrirLecture"),MB_OK
		pop eax
          .endif
            
             ret
OuvrirLecture endp

; #########################################################################
end start
